load phi_45_input_data.sage

D = -3
disc = lambda a, b1, b2, c: - D * a * c - b1**2 - D * b1 * b2 - (D**2 - D) // 4 * b2**2
odual_red = lambda b1: ((b1 + 1) % 3 - 1, 0)

def exp_multiplication(exp1,exp2,aprec,cprec):
    exp_temp = {}
    for exponent1 in exp1:
        for exponent2 in exp2:
            if ((exponent1[0] + exponent2[0] < aprec) and (exponent1[3] + exponent2[3] < cprec)):
                try:
                    exp_temp[(exponent1[0] + exponent2[0],exponent1[1] + exponent2[1],exponent1[2] + exponent2[2],exponent1[3] + exponent2[3])] += exp1[exponent1] * exp2[exponent2]
                except(KeyError):
                    exp_temp.update({(exponent1[0] + exponent2[0],exponent1[1] + exponent2[1],exponent1[2] + exponent2[2],exponent1[3] + exponent2[3]):exp1[exponent1] * exp2[exponent2]})
    exp = {}
    for exponent in exp_temp:
        if (exp_temp[exponent]<>0):
            exp.update({exponent:exp_temp[exponent]})
    return exp

def borcherds_product_phi_45(prec,discprec):
    vv = load("phi_45_input_data.sobj")
    borcherds_factors={0:{(3,3,2,4):1}}
    factor_counter=0
    cprec = (prec - 4)*((prec - 4) - ceil((discprec+1)/Integer(-D)))
    b2_max = 0
    b1_max = 0
    ## a > 0
    for a in range(1,prec-4+1):
        cmin = ceil((discprec+1)/Integer(-D*a))
        for c in range(cmin,cprec+1):
            B2 = isqrt(4*a*c - 4*(discprec+1)/Integer(3))
            for b2 in range(-B2,B2+1):
                B1 = sqrt(-4*D*a*c + D*b2^2 - 4*(discprec+1))
                b1min = ceil((-D*b2 - B1)/Integer(2))
                b1max = floor((-D*b2 + B1)/Integer(2))
                for b1 in range(b1min,b1max+1):
                    vv_coeff = vv[odual_red(b1)][disc(a,b1,b2,c)]
                    if (c > 0):
                        max_n = min(vv_coeff,cprec//c,(prec-4)//a)
                    else:
                        max_n = min(vv_coeff,(prec-4)//a)
                    if (max_n > 0):
                        factor_counter += 1
                        new_factor={(0,0,0,0):1}
                        for n in range(1,max_n+1):
                            new_factor.update({(n*a,n*b1,n*b2,n*c):binomial(vv_coeff,n)*(-1)^(n)})
                            b2_max = max(b2_max,n*b2)
                            b1_max = max(b1_max,n*b1)
                        borcherds_factors.update({factor_counter:new_factor})
    ## a = 0, c > 0
    for c in range(1,cprec+1):
        a = 0
        B2 = isqrt(4*a*c - 4*(discprec+1)/Integer(3))
        for b2 in range(-B2,B2+1):
            B1 = sqrt(-4*D*a*c + D*b2^2 - 4*(discprec+1))
            b1min = ceil((-D*b2 - B1)/Integer(2))
            b1max = floor((-D*b2 + B1)/Integer(2))
            for b1 in range(b1min,b1max+1):
                vv_coeff = vv[odual_red(b1)][disc(a,b1,b2,c)]
                max_n = min(vv_coeff,cprec//c)
                if (max_n > 0):
                    factor_counter += 1
                    new_factor={(0,0,0,0):1}
                    for n in range(1,max_n+1):
                        new_factor.update({(n*a,n*b1,n*b2,n*c):binomial(vv_coeff,n)*(-1)^(n)})
                        b2_max = max(b2_max,n*b2)
                        b1_max = max(b1_max,n*b1)
                    borcherds_factors.update({factor_counter:new_factor})
    ## a = 0, c = 0, b2 < 0
    a = 0
    c = 0
    B2 = isqrt(4*a*c - 4*(discprec+1)/Integer(3))
    for b2 in range(-B2,0):
        B1 = sqrt(-4*D*a*c + D*b2^2 - 4*(discprec+1))
        b1min = ceil((-D*b2 - B1)/Integer(2))
        b1max = floor((-D*b2 + B1)/Integer(2))
        for b1 in range(b1min,b1max+1):
            vv_coeff = vv[odual_red(b1)][disc(a,b1,b2,c)]
            max_n = min(vv_coeff,floor((-sqrt(4*(prec-1)*(prec-1))-(b2_max+2))/b2))
            if (max_n > 0):
                factor_counter += 1
                new_factor={(0,0,0,0):1}
                for n in range(1,max_n+1):
                    new_factor.update({(n*a,n*b1,n*b2,n*c):binomial(vv_coeff,n)*(-1)^(n)})
                    b1_max = max(b1_max,n*b1)
                borcherds_factors.update({factor_counter:new_factor})
    ## a = 0, c = 0, b2 = 0, b1 < 0
    a = 0
    c = 0
    b2 = 0
    B1 = sqrt(-4*D*a*c + D*b2^2 - 4*(discprec+1))
    b1min = ceil((-D*b2 - B1)/Integer(2))
    for b1 in range(b1min,0):
        vv_coeff = vv[odual_red(b1)][disc(a,b1,b2,c)]
        max_n = min(vv_coeff,floor((-sqrt(D^2*(prec-1)*(prec-1))-sqrt(-D*(prec-1)*(prec-1))-(b1_max+3))/b1))
        if (max_n > 0):
            factor_counter += 1
            new_factor={(0,0,0,0):1}
            for n in range(1,max_n+1):
                new_factor.update({(n*a,n*b1,n*b2,n*c):binomial(vv_coeff,n)*(-1)^(n)})
            borcherds_factors.update({factor_counter:new_factor})
    phi_45 = {}
    phi_45.update(borcherds_factors[0])
    for i in range(1,factor_counter+1):
        phi_45 = exp_multiplication(phi_45,borcherds_factors[i],prec,cprec+3+1)
    phi_45_prec={}
    for exponent in phi_45:
        if ((exponent[0] >= 0) and (exponent[0] < prec) and (exponent[3] >= 0) and (exponent[3] < prec) and disc(exponent[0],exponent[1],exponent[2],exponent[3]) >= 0):
            phi_45_prec.update({exponent:phi_45[exponent]})
    return phi_45_prec

def test(phi_45_s,prec):
    phi_45 = load("phi_45_naive.sobj")
    for exponent in phi_45:
        if ((exponent[0] < prec) and (exponent[3] < prec)):
            if (phi_45_s[exponent] <> phi_45[exponent]):
                raise RuntimeError()
